Open CASCADE Technology: BlendFunc_Ruled Class Reference

Open CASCADE Technology 6.8.0

- Main Page
- Related Pages
- Namespaces
- Data Structures
- Files

- Data Structures
- Data Structure Index
- Class Hierarchy
- Data Fields

Public Member Functions
BlendFunc_Ruled Class Reference

`#include <BlendFunc_Ruled.hxx>`

Inheritance diagram for BlendFunc_Ruled:
[legend]

## Public Member Functions
| BlendFunc_Ruled (const Handle< Adaptor3d_HSurface > &S1, const Handle< Adaptor3d_HSurface > &S2, const Handle< Adaptor3d_HCurve > &C)
Standard_Integer | NbEquations () const
| returns the number of equations of the function. More...
Standard_Boolean | Value (const math_Vector &X, math_Vector &F)
| computes the values <F> of the Functions for the variable <X>. Returns True if the computation was done successfully, False otherwise. More...
Standard_Boolean | Derivatives (const math_Vector &X, math_Matrix &D)
| returns the values <D> of the derivatives for the variable <X>. Returns True if the computation was done successfully, False otherwise. More...
Standard_Boolean | Values (const math_Vector &X, math_Vector &F, math_Matrix &D)
| returns the values <F> of the functions and the derivatives <D> for the variable <X>. Returns True if the computation was done successfully, False otherwise. More...
void | Set (const Standard_Real Param)
| Sets the value of the parameter along the guide line. This determines the plane in which the solution has to be found. More...
void | Set (const Standard_Real First, const Standard_Real Last)
| Sets the bounds of the parametric interval on the guide line. This determines the derivatives in these values if the function is not Cn. More...
void | GetTolerance (math_Vector &Tolerance, const Standard_Real Tol) const
| Returns in the vector Tolerance the parametric tolerance for each of the 4 variables; Tol is the tolerance used in 3d space. More...
void | GetBounds (math_Vector &InfBound, math_Vector &SupBound) const
| Returns in the vector InfBound the lowest values allowed for each of the 4 variables. Returns in the vector SupBound the greatest values allowed for each of the 4 variables. More...
Standard_Boolean | IsSolution (const math_Vector &Sol, const Standard_Real Tol)
| Returns Standard_True if Sol is a zero of the function. Tol is the tolerance used in 3d space. The computation is made at the current value of the parameter on the guide line. More...
Standard_Real | GetMinimalDistance () const
| Returns the minimal Distance beetween two extremitys of calculed sections. More...
const gp_Pnt & | PointOnS1 () const
| Returns the point on the first surface, at parameter Sol(1),Sol(2) (Sol is the vector used in the call of IsSolution. More...
const gp_Pnt & | PointOnS2 () const
| Returns the point on the second surface, at parameter Sol(3),Sol(4) (Sol is the vector used in the call of IsSolution. More...
Standard_Boolean | IsTangencyPoint () const
| Returns True when it is not possible to compute the tangent vectors at PointOnS1 and/or PointOnS2. More...
const gp_Vec & | TangentOnS1 () const
| Returns the tangent vector at PointOnS1, in 3d space. More...
const gp_Vec2d & | Tangent2dOnS1 () const
| Returns the tangent vector at PointOnS1, in the parametric space of the first surface. More...
const gp_Vec & | TangentOnS2 () const
| Returns the tangent vector at PointOnS2, in 3d space. More...
const gp_Vec2d & | Tangent2dOnS2 () const
| Returns the tangent vector at PointOnS2, in the parametric space of the second surface. More...
void | Tangent (const Standard_Real U1, const Standard_Real V1, const Standard_Real U2, const Standard_Real V2, gp_Vec &TgFirst, gp_Vec &TgLast, gp_Vec &NormFirst, gp_Vec &NormLast) const
| Returns the tangent vector at the section, at the beginning and the end of the section, and returns the normal (of the surfaces) at these points. More...
Standard_Boolean | GetSection (const Standard_Real Param, const Standard_Real U1, const Standard_Real V1, const Standard_Real U2, const Standard_Real V2, TColgp_Array1OfPnt &tabP, TColgp_Array1OfVec &tabV)
Standard_Boolean | IsRational () const
| Returns False. More...
Standard_Real | GetSectionSize () const
| Returns the length of the maximum section. More...
void | GetMinimalWeight (TColStd_Array1OfReal &Weigths) const
| Compute the minimal value of weight for each poles of all sections. More...
Standard_Integer | NbIntervals (const GeomAbs_Shape S) const
| Returns the number of intervals for continuity <S>. May be one if Continuity(me) >= <S> More...
void | Intervals (TColStd_Array1OfReal &T, const GeomAbs_Shape S) const
| Stores in <T> the parameters bounding the intervals of continuity <S>. More...
void | GetShape (Standard_Integer &NbPoles, Standard_Integer &NbKnots, Standard_Integer &Degree, Standard_Integer &NbPoles2d)
void | GetTolerance (const Standard_Real BoundTol, const Standard_Real SurfTol, const Standard_Real AngleTol, math_Vector &Tol3d, math_Vector &Tol1D) const
| Returns the tolerance to reach in approximation to respecte BoundTol error at the Boundary AngleTol tangent error at the Boundary SurfTol error inside the surface. More...
void | Knots (TColStd_Array1OfReal &TKnots)
void | Mults (TColStd_Array1OfInteger &TMults)
Standard_Boolean | Section (const Blend_Point &P, TColgp_Array1OfPnt &Poles, TColgp_Array1OfVec &DPoles, TColgp_Array1OfVec &D2Poles, TColgp_Array1OfPnt2d &Poles2d, TColgp_Array1OfVec2d &DPoles2d, TColgp_Array1OfVec2d &D2Poles2d, TColStd_Array1OfReal &Weigths, TColStd_Array1OfReal &DWeigths, TColStd_Array1OfReal &D2Weigths)
| Used for the first and last section. More...
Standard_Boolean | Section (const Blend_Point &P, TColgp_Array1OfPnt &Poles, TColgp_Array1OfVec &DPoles, TColgp_Array1OfPnt2d &Poles2d, TColgp_Array1OfVec2d &DPoles2d, TColStd_Array1OfReal &Weigths, TColStd_Array1OfReal &DWeigths)
| Used for the first and last section. More...
void | Section (const Blend_Point &P, TColgp_Array1OfPnt &Poles, TColgp_Array1OfPnt2d &Poles2d, TColStd_Array1OfReal &Weigths)
gp_Ax1 | AxeRot (const Standard_Real Prm)
void | Resolution (const Standard_Integer IC2d, const Standard_Real Tol, Standard_Real &TolU, Standard_Real &TolV) const
Public Member Functions inherited from Blend_Function
Standard_Integer | NbVariables () const
| Returns 4. More...
const gp_Pnt & | Pnt1 () const
| Returns the point on the first support. More...
const gp_Pnt & | Pnt2 () const
| Returns the point on the seconde support. More...
virtual Standard_Boolean | TwistOnS1 () const
virtual Standard_Boolean | TwistOnS2 () const
Public Member Functions inherited from Blend_AppFunction
Standard_Real | Parameter (const Blend_Point &P) const
| Returns the parameter of the point P. Used to impose the parameters in the approximation. More...
Public Member Functions inherited from math_FunctionSet
virtual void | Delete ()
virtual | ~math_FunctionSet ()
virtual Standard_Integer | GetStateNumber ()
| Returns the state of the function corresponding to the latestcall of any methods associated with the function. This function is called by each of the algorithms described later which define the function Integer Algorithm::StateNumber(). The algorithm has the responsibility to call this function when it has found a solution (i.e. a root or a minimum) and has to maintain the association between the solution found and this StateNumber. Byu default, this method returns 0 (which means for the algorithm: no state has been saved). It is the responsibility of the programmer to decide if he needs to save the current state of the function and to return an Integer that allows retrieval of the state. More...

## Constructor & Destructor Documentation

BlendFunc_Ruled::BlendFunc_Ruled | ( | const Handle< Adaptor3d_HSurface > & | S1,
|  | const Handle< Adaptor3d_HSurface > & | S2,
|  | const Handle< Adaptor3d_HCurve > & | C
| ) |  |

## Member Function Documentation

gp_Ax1 BlendFunc_Ruled::AxeRot | ( | const Standard_Real | Prm | ) |

Standard_Boolean BlendFunc_Ruled::Derivatives | ( | const math_Vector & | X,
|  | math_Matrix & | D
| ) |  |
| virtual

returns the values <D> of the derivatives for the variable <X>. Returns True if the computation was done successfully, False otherwise.

Implements Blend_Function.

void BlendFunc_Ruled::GetBounds | ( | math_Vector & | InfBound,
|  | math_Vector & | SupBound
| ) |  | const
| virtual

Returns in the vector InfBound the lowest values allowed for each of the 4 variables. Returns in the vector SupBound the greatest values allowed for each of the 4 variables.

Implements Blend_Function.

Standard_Real BlendFunc_Ruled::GetMinimalDistance | ( |  | ) | const
| virtual

Returns the minimal Distance beetween two extremitys of calculed sections.

Implements Blend_AppFunction.

void BlendFunc_Ruled::GetMinimalWeight | ( | TColStd_Array1OfReal & | Weigths | ) | const
| virtual

Compute the minimal value of weight for each poles of all sections.

Implements Blend_AppFunction.

Standard_Boolean BlendFunc_Ruled::GetSection | ( | const Standard_Real | Param,
|  | const Standard_Real | U1,
|  | const Standard_Real | V1,
|  | const Standard_Real | U2,
|  | const Standard_Real | V2,
|  | TColgp_Array1OfPnt & | tabP,
|  | TColgp_Array1OfVec & | tabV
| ) |  |

Standard_Real BlendFunc_Ruled::GetSectionSize | ( |  | ) | const
| virtual

Returns the length of the maximum section.

Implements Blend_AppFunction.

void BlendFunc_Ruled::GetShape | ( | Standard_Integer & | NbPoles,
|  | Standard_Integer & | NbKnots,
|  | Standard_Integer & | Degree,
|  | Standard_Integer & | NbPoles2d
| ) |  |
| virtual

Implements Blend_Function.

void BlendFunc_Ruled::GetTolerance | ( | math_Vector & | Tolerance,
|  | const Standard_Real | Tol
| ) |  | const
| virtual

Returns in the vector Tolerance the parametric tolerance for each of the 4 variables; Tol is the tolerance used in 3d space.

Implements Blend_Function.

void BlendFunc_Ruled::GetTolerance | ( | const Standard_Real | BoundTol,
|  | const Standard_Real | SurfTol,
|  | const Standard_Real | AngleTol,
|  | math_Vector & | Tol3d,
|  | math_Vector & | Tol1D
| ) |  | const
| virtual

Returns the tolerance to reach in approximation to respecte BoundTol error at the Boundary AngleTol tangent error at the Boundary SurfTol error inside the surface.

Implements Blend_Function.

void BlendFunc_Ruled::Intervals | ( | TColStd_Array1OfReal & | T,
|  | const GeomAbs_Shape | S
| ) |  | const
| virtual

Stores in <T> the parameters bounding the intervals of continuity <S>.

The array must provide enough room to accomodate for the parameters. i.e. T.Length() > NbIntervals() raises OutOfRange from Standard

Implements Blend_AppFunction.

Standard_Boolean BlendFunc_Ruled::IsRational | ( |  | ) | const
| virtual

Returns False.

Implements Blend_AppFunction.

Standard_Boolean BlendFunc_Ruled::IsSolution | ( | const math_Vector & | Sol,
|  | const Standard_Real | Tol
| ) |  |
| virtual

Returns Standard_True if Sol is a zero of the function. Tol is the tolerance used in 3d space. The computation is made at the current value of the parameter on the guide line.

Implements Blend_Function.

Standard_Boolean BlendFunc_Ruled::IsTangencyPoint | ( |  | ) | const
| virtual

Returns True when it is not possible to compute the tangent vectors at PointOnS1 and/or PointOnS2.

Implements Blend_Function.

void BlendFunc_Ruled::Knots | ( | TColStd_Array1OfReal & | TKnots | ) |
| virtual

Implements Blend_Function.

void BlendFunc_Ruled::Mults | ( | TColStd_Array1OfInteger & | TMults | ) |
| virtual

Implements Blend_Function.

Standard_Integer BlendFunc_Ruled::NbEquations | ( |  | ) | const
| virtual

returns the number of equations of the function.

Implements Blend_Function.

Standard_Integer BlendFunc_Ruled::NbIntervals | ( | const GeomAbs_Shape | S | ) | const
| virtual

Returns the number of intervals for continuity <S>. May be one if Continuity(me) >= <S>

Implements Blend_AppFunction.

const gp_Pnt& BlendFunc_Ruled::PointOnS1 | ( |  | ) | const
| virtual

Returns the point on the first surface, at parameter Sol(1),Sol(2) (Sol is the vector used in the call of IsSolution.

Implements Blend_Function.

const gp_Pnt& BlendFunc_Ruled::PointOnS2 | ( |  | ) | const
| virtual

Returns the point on the second surface, at parameter Sol(3),Sol(4) (Sol is the vector used in the call of IsSolution.

Implements Blend_Function.

void BlendFunc_Ruled::Resolution | ( | const Standard_Integer | IC2d,
|  | const Standard_Real | Tol,
|  | Standard_Real & | TolU,
|  | Standard_Real & | TolV
| ) |  | const
| virtual

Implements Blend_AppFunction.

Standard_Boolean BlendFunc_Ruled::Section | ( | const Blend_Point & | P,
|  | TColgp_Array1OfPnt & | Poles,
|  | TColgp_Array1OfVec & | DPoles,
|  | TColgp_Array1OfVec & | D2Poles,
|  | TColgp_Array1OfPnt2d & | Poles2d,
|  | TColgp_Array1OfVec2d & | DPoles2d,
|  | TColgp_Array1OfVec2d & | D2Poles2d,
|  | TColStd_Array1OfReal & | Weigths,
|  | TColStd_Array1OfReal & | DWeigths,
|  | TColStd_Array1OfReal & | D2Weigths
| ) |  |
| virtual

Used for the first and last section.

Reimplemented from Blend_Function.

Standard_Boolean BlendFunc_Ruled::Section | ( | const Blend_Point & | P,
|  | TColgp_Array1OfPnt & | Poles,
|  | TColgp_Array1OfVec & | DPoles,
|  | TColgp_Array1OfPnt2d & | Poles2d,
|  | TColgp_Array1OfVec2d & | DPoles2d,
|  | TColStd_Array1OfReal & | Weigths,
|  | TColStd_Array1OfReal & | DWeigths
| ) |  |
| virtual

Used for the first and last section.

Implements Blend_Function.

void BlendFunc_Ruled::Section | ( | const Blend_Point & | P,
|  | TColgp_Array1OfPnt & | Poles,
|  | TColgp_Array1OfPnt2d & | Poles2d,
|  | TColStd_Array1OfReal & | Weigths
| ) |  |
| virtual

Implements Blend_Function.

void BlendFunc_Ruled::Set | ( | const Standard_Real | Param | ) |
| virtual

Sets the value of the parameter along the guide line. This determines the plane in which the solution has to be found.

Implements Blend_Function.

void BlendFunc_Ruled::Set | ( | const Standard_Real | First,
|  | const Standard_Real | Last
| ) |  |
| virtual

Sets the bounds of the parametric interval on the guide line. This determines the derivatives in these values if the function is not Cn.

Implements Blend_Function.

void BlendFunc_Ruled::Tangent | ( | const Standard_Real | U1,
|  | const Standard_Real | V1,
|  | const Standard_Real | U2,
|  | const Standard_Real | V2,
|  | gp_Vec & | TgFirst,
|  | gp_Vec & | TgLast,
|  | gp_Vec & | NormFirst,
|  | gp_Vec & | NormLast
| ) |  | const
| virtual

Returns the tangent vector at the section, at the beginning and the end of the section, and returns the normal (of the surfaces) at these points.

Implements Blend_Function.

const gp_Vec2d& BlendFunc_Ruled::Tangent2dOnS1 | ( |  | ) | const
| virtual

Returns the tangent vector at PointOnS1, in the parametric space of the first surface.

Implements Blend_Function.

const gp_Vec2d& BlendFunc_Ruled::Tangent2dOnS2 | ( |  | ) | const
| virtual

Returns the tangent vector at PointOnS2, in the parametric space of the second surface.

Implements Blend_Function.

const gp_Vec& BlendFunc_Ruled::TangentOnS1 | ( |  | ) | const
| virtual

Returns the tangent vector at PointOnS1, in 3d space.

Implements Blend_Function.

const gp_Vec& BlendFunc_Ruled::TangentOnS2 | ( |  | ) | const
| virtual

Returns the tangent vector at PointOnS2, in 3d space.

Implements Blend_Function.

Standard_Boolean BlendFunc_Ruled::Value | ( | const math_Vector & | X,
|  | math_Vector & | F
| ) |  |
| virtual

computes the values <F> of the Functions for the variable <X>. Returns True if the computation was done successfully, False otherwise.

Implements Blend_Function.

Standard_Boolean BlendFunc_Ruled::Values | ( | const math_Vector & | X,
|  | math_Vector & | F,
|  | math_Matrix & | D
| ) |  |
| virtual

returns the values <F> of the functions and the derivatives <D> for the variable <X>. Returns True if the computation was done successfully, False otherwise.

Implements Blend_Function.

The documentation for this class was generated from the following file:

- BlendFunc_Ruled.hxx